<?php
/*
  Plugin Name: ابزارک نمایش موضوعات با افکت
  Plugin URI: http://skatox.com/blog/jquery-categories-list-widget/
  Description: یک ابزارک کوچک که موضوعات سایت شما را افکتی زیبا نمایش خواهد داد.
  Author: وحید محمدی
  Version: 2.2.5
  Author URI: http://blog.vahidd.com/
    Author: HAMYARWP
  Author URI: http://hamyarwp.com

  Copyleft 2010-2011  Miguel Useche  (email : migueluseche@skatox.com)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
include plugin_dir_path(__FILE__).'/feed.class.php';

if(!class_exists('hwpfeed')){

	deactivate_plugins( plugin_basename( __FILE__ ) );
	
}
$jcl_dir = preg_replace("/^.*[\/\\\]/", "", dirname(__FILE__));
define("JCL_URL", "/wp-content/plugins/" . $jcl_dir . "/");
define("JCL_DIR", WP_PLUGIN_DIR . DIRECTORY_SEPARATOR . $jcl_dir . DIRECTORY_SEPARATOR );
define("JCL_JS_FILENAME", "jcl.js");
//Loads plugin's language file
load_plugin_textdomain('jcl_i18n', false, basename( dirname( __FILE__ ) ) . '/lang' );

/**
 * Loads plugin's options, interprets it for internal use
 * @return array of custom options
 */
function jcl_load_options() {
    //Loads options
    $options = get_option('jquery_categories_list');
    $jcl_options = array();
    $jcl_options['showcount'] = $options['showcount'];
    $jcl_options['title'] = empty($options['title']) ? __('Default Title', 'jcl_i18n') : $options['title'];
    $jcl_options['exclude'] = $options['exclude'];
    $jcl_options['orderby'] =  empty($options['orderby'])? 'name' : $options['orderby'];
    $jcl_options['orderdir'] =  empty($options['orderdir'])? 'ASC' : $options['orderdir'];

    switch ($options['symbol']) {
        case '0':
            $jcl_options['ex_sym'] = ' ';
            $jcl_options['con_sym'] = ' ';
            break;
        case '1':
            $jcl_options['ex_sym'] = '►';
            $jcl_options['con_sym'] = '▼';
            break;
        case '2':
            $jcl_options['ex_sym'] = '(+)';
            $jcl_options['con_sym'] = '(-)';
            break;
        case '3':
            $jcl_options['ex_sym'] = '[+]';
            $jcl_options['con_sym'] = '[-]';
            break;
        default:
            $jcl_options['ex_sym'] = '>';
            $jcl_options['con_sym'] = 'v';
            break;
    }

    switch ($options['effect']) {
        case 'slide':
            $jcl_options['fx_in'] = 'slideDown';
            $jcl_options['fx_out'] = 'slideUp';
            break;
        case 'fade':
            $jcl_options['fx_in'] = 'fadeIn';
            $jcl_options['fx_out'] = 'fadeOut';
            break;
    }
    return $jcl_options;
}

/**
 * Returns all categories
 * @return an array of categories.
 */
function jcl_get_categories() {
    $options = get_option('jquery_categories_list');

    return get_categories(
                    array(
                        'type' => 'post',
                        'child_of' => 0,
                        'orderby' => $options['orderby'],
                        'order' => $options['orderdir'],
                        'hide_empty' => 1,
                        'hierarchical' => 1,
                        'taxonomy' => 'category',
                        'pad_counts' => false
                    )
    );
}

/**
 * Gets an array of children categories as an array given its parent id, this
 * functions avoiding excesive database calls
 * @param $cat categories object
 * @param $parent_id category's parent id
 */
function jcl_get_categories_array($cat, $parent_id) {
    $categories = array();

    foreach ($cat as $c)
        if ($c->parent == $parent_id)
            $categories[] = $c;

    return $categories;
}

/**
 * Creates HTML code recursive
 */
function jcl_print_category($cat, $parent_id, $options) {
    $html = '';
    $child_html = '';
    $categories = jcl_get_categories_array($cat, $parent_id);
    $cat_to_exc = unserialize($options['exclude']);

    foreach ($categories as $category) {

        if (is_array($cat_to_exc))
            $exclude = in_array($category->term_id, $cat_to_exc);
        else
            $exclude = false;

        if (!$exclude)
            $child_html = jcl_print_category($cat, $category->cat_ID, $options);

        if (!empty($category->cat_name) && !$exclude) {
            $html .= '<li class="jcl_category"';
            
            if ($parent_id > 0)
                $html .=' style="display:none;" ';
            
            $html.='><a href="' . get_category_link($category->term_id) . '" >' . $category->cat_name;

            if ($options['showcount'] == 'true')
                $html.=' (' . $category->count . ')';

            $html.='</a>';

            if (!empty($child_html)) {
                $html.= '<a class="jcl_link" href="'. get_category_link($category->term_id) . '" title="' . __('View Sub-Categories', 'jcl_i18n') . '">';
                $html.= '<span class="jcl_symbol" style="padding-left:5px">';
                $html.= htmlspecialchars($options['ex_sym']) . '</span></a>';
                $html .= '<ul>' . $child_html . '</ul>';
            }

            $html .= '</li>';
        }
    }

    return $html;
}

/**
 * Function to generate JS file
 */
function jcl_build_js_file(){

    $options = jcl_load_options();
    $file = JCL_DIR . JCL_JS_FILENAME;

    $ex_txt = __('View Sub-Categories', 'jcl_i18n');
    $con_txt = __('Hide Sub-Categories', 'jcl_i18n');

    $script = "
    function jquery_categories_list_animate(clicked_obj){
        if(jQuery(clicked_obj).parent().children('ul').children('li').is(':hidden')){
            jQuery(clicked_obj).parent().children('ul').children('li').{$options['fx_in']}();
            jQuery(clicked_obj).parent().children('a').children('.jcl_symbol').html('{$options['con_sym']}&nbsp;');
                    jQuery(clicked_obj).parent().children('a').children('.jcl_symbol').attr('title','{$con_txt}');
        }
        else
        {
            jQuery(clicked_obj).parent().children('a').children('.jcl_symbol').html('{$options['ex_sym']}&nbsp;');
                    jQuery(clicked_obj).parent().children('a').children('.jcl_symbol').attr('title','{$ex_txt}');
            jQuery(clicked_obj).parent().children('ul').children('li').{$options['fx_out']}();
        }
        jQuery(clicked_obj).parent().toggleClass('expanded');
    }

    jQuery(document).ready(function() {
        jQuery('li.jcl_category a.jcl_link').bind('click', function(){
            jquery_categories_list_animate(this);
                    return false;
        });
    });";

    return file_put_contents($file, $script);
}

/**
 * Builds categories list's HTML code
 */
function jcl_build_html_code($jcl_options) {
    global $wp_locale;
    $options = jcl_load_options();

    //Loads all categories in a object
    $cats = jcl_get_categories();

    $html = '<ul>';
    $html.= jcl_print_category($cats, 0, $options);
    $html.= '</ul>';

    return $html;
}

/**
 * Function wich filters any [jQuery Categories List] text inside post to display categories list
 */
function widget_filter_jquery_categories($content) {
    $jcl_options = jcl_load_options();
    $content = str_ireplace('[jQuery Categories List]', jcl_build_html_code($jcl_options), $content);
    return $content;
}

/**
 * Function wich displays configuration form used at widgets area at Administration page
 */
function widget_display_jquery_categories_control() {

    $cats = jcl_get_categories();
    $options = get_option('jquery_categories_list');
    $cat_exclude = unserialize($options['exclude']);

    //If submit button was pressed the variables are loaded by POST
    if ($_POST['jquery_categories_submit']) {
        $options['title'] = stripslashes($_POST['jquery_categories_title']);
        $options['symbol'] = $_POST['jquery_categories_symbol'];
        $options['effect'] = stripslashes($_POST['jquery_categories_effect']);
        $options['orderby'] = $_POST['jquery_categories_orderby'];
        $options['orderdir'] = $_POST['jquery_categories_orderdir'];
        $options['exclude'] = serialize($_POST['jquery_categories_exclude']);
        $options['showcount'] = isset($_POST['jquery_categories_showcount']);
             
        //Update options in the Wordpress database
        update_option('jquery_categories_list', $options);
        
        //Creates js file
        jcl_build_js_file();
    }
    ?>

    <dl>
        <dt><strong><?php _e('Title') ?></strong></dt>
        <dd>
            <input name="jquery_categories_title" type="text" value="<?php echo $options['title']; ?>" />
        </dd>
        <dt><strong><?php _e('Trigger Symbol', 'jcl_i18n') ?></strong></dt>
        <dd>
            <select id="jquery_categories_symbol" name="jquery_categories_symbol">
                <option value="0"  <?php if ($options['symbol'] == '0') echo 'selected="selected"' ?> ><?php _e('Empty Space', 'jcl_i18n') ?></option>
                <option value="1"  <?php if ($options['symbol'] == '1') echo 'selected="selected"' ?> >► ▼</option>
                <option value="2"  <?php if ($options['symbol'] == '2') echo 'selected="selected"' ?> >(+) (-)</option>
                <option value="3"  <?php if ($options['symbol'] == '3') echo 'selected="selected"' ?> >[+] [-]</option>
            </select>
        </dd>
        <dt><strong><?php _e('Effect', 'jcl_i18n') ?></strong></dt>
        <dd>
            <select id="jquery_categories_effect" name="jquery_categories_effect">
                <option value="slide"  <?php if ($options['effect'] == 'slide') echo 'selected="selected"' ?> ><?php _e('Slide (Accordion)', 'jcl_i18n') ?></option>
                <option value="fade" <?php if ($options['effect'] == 'fade')  echo 'selected="selected"' ?> ><?php _e('Fade', 'jcl_i18n') ?></option>
            </select>
        </dd>
        <dt><strong><?php _e('Order By', 'jcl_i18n') ?></strong></dt>
        <dd>
            <select id="jquery_categories_orderby" name="jquery_categories_orderby">
                <option value="name"  <?php if ($options['orderby'] == 'name') echo 'selected="selected"' ?> ><?php _e('Name', 'jcl_i18n') ?></option>
                <option value="id"  <?php if ($options['orderby'] == 'id') echo 'selected="selected"' ?> ><?php _e('Category ID', 'jcl_i18n') ?></option>
                <option value="count"  <?php if ($options['orderby'] == 'count') echo 'selected="selected"' ?> ><?php _e('Entries count', 'jcl_i18n') ?></option>
            </select>
            <select id="jquery_categories_orderdir" name="jquery_categories_orderdir">
                <option value="ASC"  <?php if ($options['orderdir'] == 'ASC') echo 'selected="selected"' ?> ><?php _e('ASC', 'jcl_i18n') ?></option>
                <option value="DESC"  <?php if ($options['orderdir'] == 'DESC') echo 'selected="selected"' ?> ><?php _e('DESC', 'jcl_i18n') ?></option>
            </select>
        </dd>
        <dd>
            <input id="jquery_categories_showcount" name="jquery_categories_showcount" type="checkbox" <?php if ($options['showcount']) echo 'checked="checked"' ?> />
    <?php _e('Show number of posts', 'jcl_i18n') ?>
        </dd>
        <dt><strong><?php _e('Categories to exclude:', 'jcl_i18n') ?></strong></dt>
        <dd>
            <select id="jquery_categories_exclude" name="jquery_categories_exclude[]" style="height:75px;" multiple="multiple">
                <?php
                foreach ($cats as $cat) {
                    $checked = (in_array($cat->term_id, $cat_exclude)) ? 'selected="selected"' : '';
                    echo "<option value=\"{$cat->term_id}\" {$checked}>{$cat->cat_name}</option>";
                }
                ?>
            </select>
        </dd>
    </dl> 
    <input type="hidden" name="jquery_categories_submit" value="1" />
    <?php
}

/**
 * Displays the categories list
 */
function widget_display_jQuery_categories($args) {
    extract($args);
    $jcl_options = jcl_load_options();

    echo $before_widget;
    echo $before_title;
    echo $jcl_options['title'];
    echo $after_title;
    echo jcl_build_html_code($jcl_options);
    echo $after_widget;
}

function widget_display_jQuery_categories_init() {
    //Includes translation file
    if (function_exists("load_plugin_textdomain")) {
        load_plugin_textdomain('jcl_i18n', JCL_DIR . "/lang/");
    }

    //Includes dynamic js script and loads jquery if it is not loaded
    if (function_exists("wp_enqueue_script") && !is_admin()) {
        
        if(!file_exists(JCL_DIR . JCL_JS_FILENAME))
            jcl_build_js_file();
        
        wp_enqueue_script('jquery_categories_list', get_option("siteurl") . JCL_URL . JCL_JS_FILENAME , array('jquery'), false, true);
    }

    //register this plugin
    wp_register_sidebar_widget(
            'jquery-categories-list-widget', 'jQuery Categories List Widget', 'widget_display_jQuery_categories', array('description' => __('A simple jQuery widget for displaying a categories collapsible list with some effects.', 'jcl_i18n')
    ));
    wp_register_widget_control('jquery-categories-list-widget', 'jQuery Categories List Widget', 'widget_display_jquery_categories_control');
}

add_action('init', 'widget_display_jQuery_categories_init');
add_filter('the_content', 'widget_filter_jquery_categories');

//filters on widgets (thanks to Ramiro García <ramiro(at)inbytes.com>)
add_action('widget_text', 'widget_filter_jquery_categories');